﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.Linq.Expressions;
using System.Text;
using AdventureWorks;


namespace CompiledQueries1
{
    class Program
    {
        static void Main(string[] args) {
            #region init
            var tmp = new CustomerRepository();
            tmp.GetCustomers(CustomerRepository.Sex.Man, "A").ToList();
            tmp.Dispose();
            var tmp2 = new CompiledCustomerRepository();
            tmp2.GetCustomers(CompiledCustomerRepository.Sex.Man, "A").ToList();
            tmp2.Dispose();

            var ergebnis = new List<Customer>();
            #endregion

            #region Einfache Abfrage
            var timer = DateTime.Now;
            using (var repository = new CustomerRepository())
            {
                ergebnis = repository.GetCustomers(CustomerRepository.Sex.Man, "B").ToList();
            }
            Console.WriteLine("Non compiled: 1x {1} entries in {0} ms", (DateTime.Now - timer).TotalMilliseconds, ergebnis.Count);

            timer = DateTime.Now;

            using (var repository = new CompiledCustomerRepository())
            {
                ergebnis = repository.GetCustomers(CompiledCustomerRepository.Sex.Man, "B");
            }
            Console.WriteLine("Compiled: 1x {1} entries in {0} ms", (DateTime.Now - timer).TotalMilliseconds, ergebnis.Count);
            Console.WriteLine();
            #endregion

            #region 10 Abfragen
            timer = DateTime.Now;
            for (int i = 0; i < 10; i++)
            {
                using (var repository = new CustomerRepository())
                {
                    ergebnis = repository.GetCustomers(CustomerRepository.Sex.Man, "B").ToList();
                }
            }
            Console.WriteLine("Non compiled: 10x {1} entries in {0} ms", (DateTime.Now - timer).TotalMilliseconds, ergebnis.Count);

            timer = DateTime.Now;

            for (int i = 0; i < 10; i++)
            {
                using (var repository = new CompiledCustomerRepository())
                {
                    ergebnis = repository.GetCustomers(CompiledCustomerRepository.Sex.Man, "B");
                }
            }
            Console.WriteLine("Compiled: 10x {1} entries in {0} ms", (DateTime.Now - timer).TotalMilliseconds, ergebnis.Count);
            Console.WriteLine();
            #endregion

            #region 100 Abfragen
            timer = DateTime.Now;
            for (int i = 0; i < 100; i++)
            {
                using (var repository = new CustomerRepository())
                {
                    ergebnis = repository.GetCustomers(CustomerRepository.Sex.Man, "B").ToList();
                }
            }
            Console.WriteLine("Non compiled: 100x {1} entries in {0} ms", (DateTime.Now - timer).TotalMilliseconds, ergebnis.Count);

            timer = DateTime.Now;

            for (int i = 0; i < 100; i++)
            {
                using (var repository = new CompiledCustomerRepository())
                {
                    ergebnis = repository.GetCustomers(CompiledCustomerRepository.Sex.Man, "B");
                }
            }
            Console.WriteLine("Compiled: 100x {1} entries in {0} ms", (DateTime.Now - timer).TotalMilliseconds, ergebnis.Count);
            Console.WriteLine();
            #endregion

            #region 500 Abfragen
            timer = DateTime.Now;
            for (int i = 0; i < 500; i++)
            {
                using (var repository = new CustomerRepository())
                {
                    ergebnis = repository.GetCustomers(CustomerRepository.Sex.Man, "B").ToList();
                }
            }
            Console.WriteLine("Non compiled: 500x {1} entries in {0} ms", (DateTime.Now - timer).TotalMilliseconds, ergebnis.Count);

            timer = DateTime.Now;

            for (int i = 0; i < 500; i++)
            {
                using (var repository = new CompiledCustomerRepository())
                {
                    ergebnis = repository.GetCustomers(CompiledCustomerRepository.Sex.Man, "B");
                }
            }
            Console.WriteLine("Compiled: 500x {1} entries in {0} ms", (DateTime.Now - timer).TotalMilliseconds, ergebnis.Count);
            Console.WriteLine();
            #endregion

            #region 2500 Abfragen
            timer = DateTime.Now;
            for (int i = 0; i < 2500; i++)
            {
                using (var repository = new CustomerRepository())
                {
                    ergebnis = repository.GetCustomers(CustomerRepository.Sex.Man, "B").ToList();
                }
            }
            Console.WriteLine("Non compiled: 2500x {1} entries in {0} ms", (DateTime.Now - timer).TotalMilliseconds, ergebnis.Count);

            timer = DateTime.Now;

            for (int i = 0; i < 2500; i++)
            {
                using (var repository = new CompiledCustomerRepository())
                {
                    ergebnis = repository.GetCustomers(CompiledCustomerRepository.Sex.Man, "B");
                }
            }
            Console.WriteLine("Compiled: 2500x {1} entries in {0} ms", (DateTime.Now - timer).TotalMilliseconds, ergebnis.Count);
            Console.WriteLine();
            #endregion

            #region 10000 Abfragen
            timer = DateTime.Now;
            for (int i = 0; i < 10000; i++)
            {
                using (var repository = new CustomerRepository())
                {
                    ergebnis = repository.GetCustomers(CustomerRepository.Sex.Man, "B").ToList();
                }
            }
            Console.WriteLine("Non compiled: 10000x {1} entries in {0} ms", (DateTime.Now - timer).TotalMilliseconds, ergebnis.Count);

            timer = DateTime.Now;

            for (int i = 0; i < 10000; i++)
            {
                using (var repository = new CompiledCustomerRepository())
                {
                    ergebnis = repository.GetCustomers(CompiledCustomerRepository.Sex.Man, "B");
                }
            }
            Console.WriteLine("Compiled: 10000x {1} entries in {0} ms", (DateTime.Now - timer).TotalMilliseconds, ergebnis.Count);
            Console.WriteLine();
            #endregion

            Console.WriteLine("Return zum Beenden drücken...");
            Console.ReadLine();
        }
    }
}
