﻿using System;
using System.Collections.Generic;
using System.Linq;
using AdventureWorks;


namespace CompiledQueries1 {
    internal class Program {
        private static void Main(string[] args) {
            using (var repository = new CustomerRepository()) {
                int gesamtzahl = repository.GetCustomers().Count();
                int gesamtMaenner = repository.GetCustomers(CustomerRepository.Sex.Man).Count();
                int gesamtFrauen = repository.GetCustomers(CustomerRepository.Sex.Woman).Count();
                List<Customer> customerListe = repository.GetCustomers(CustomerRepository.Sex.Woman, "G").ToList();

                Console.WriteLine("Es gibt insgesamt {0} Kundeneinträge, davon {1} Männer und {2} Frauen.",
                    gesamtzahl,
                    gesamtMaenner,
                    gesamtFrauen);
                Console.WriteLine();
                Console.WriteLine(@"Frauen, deren Nachname mit einem ""G"" beginnt:");
                for (int index = 0; index < customerListe.Count; index++) {
                    Customer c = customerListe[index];
                    Console.WriteLine("{0:000} {1} {2}", index + 1, c.FirstName, c.LastName);
                }
            }

            Console.WriteLine("Return zum Beenden drücken...");
            Console.ReadLine();
        }
    }
}